// We have copied (and modified) this program from a place We don't remember ...
// I hope owner will forgive us !

import java.net.URL;
import java.sql.*;

class InterTest {

	public static void main (String argv[]) {

		// Get parameters
		if (argv.length < 4) {
			System.err.println("Usage: InterTest 'query' portNum hostName userName [userPasswd]");
			return;
		}
		String query = argv[0];
		String portNum = argv[1];
		String hostName = argv[2];
		String userName = argv[3];
		String passw = "";
		if (argv.length == 5)
			passw = argv[4];

		String url = new String("jdbc:essentia://" + hostName + ":" + portNum);

		System.out.println("\n\nDriver is: "+url);	
		System.out.println("User: "+userName);	
		System.out.println("Password: "+passw+"\n\n");	

		try {

			// Degug messages
			DriverManager.setLogStream(System.err);

			// Set needed properties
			java.util.Properties info = System.getProperties();
			info.put("user", userName);
			info.put("password", passw);
			info.put("jdbc.drivers", "intersoft.jdbc.EssentiaDriver");

			// Attempt to connect to a driver.  Each one
			// of the registered drivers will be loaded until
			// one is found that can process this URL
			
			Connection con=DriverManager.getConnection(url, userName, passw);
			//Connection con=DriverManager.getConnection (url, info);			
			
			
			// If we were unable to connect, an exception
			// would have been thrown.  So, if we get here,
			// we are successfully connected to the URL

			// Check for, and display and warnings generated
			// by the connect.

//This function is not implemented yet
//			checkForWarning (con.getWarnings ());

			// Get the DatabaseMetaData object and display
			// some information about the connection

//This function is not implemented, I think so?
/*
			DatabaseMetaData dma = con.getMetaData ();

			System.out.println("\nConnected to " + dma.getURL());
			System.out.println("Driver       " + 
				dma.getDriverName());
			System.out.println("Version      " +
				dma.getDriverVersion());
			System.out.println("");
*/

			// Create a Statement object so we can submit
			// SQL statements to the driver
			Statement stmt = con.createStatement ();
			stmt.executeUpdate ("use demo");

			ResultSet rs = stmt.executeQuery (query);
			dispResultSet (rs); // Display all columns and rows from the result set   
			stmt.close();
/*
			PreparedStatement pstmt = con.prepareStatement(query);
			pstmt.setNumeric(1, new Numeric(235, 5));
			ResultSet rs = pstmt.executeQuery();
			dispResultSet (rs);
			pstmt.close();
*/
			// Close the connection
			con.close();
		}
		catch (SQLException ex) {

			// A SQLException was generated.  Catch it and
			// display the error information.  Note that there
			// could be multiple error objects chained
			// together

			System.out.println ("\n*** SQLException caught ***\n");

			while (ex != null) {
				System.out.println ("SQLState: " +
					ex.getSQLState ());
				System.out.println ("Message:  " +
					ex.getMessage ());
				System.out.println ("Vendor:   " +
					ex.getErrorCode ());
				ex = ex.getNextException ();
				System.out.println ("");
			}
		}
		catch (java.lang.Exception ex) {

			// Got some other type of exception.  Dump it.

			ex.printStackTrace ();
		}
	}

	//-------------------------------------------------------------------
	// checkForWarning
	// Checks for and displays warnings.  Returns true if a warning
	// existed
	//-------------------------------------------------------------------

	private static boolean checkForWarning (SQLWarning warn)
			throws SQLException
	{
		boolean rc = false;

		// If a SQLWarning object was given, display the
		// warning messages.  Note that there could be
		// multiple warnings chained together

		if (warn != null) {
			System.out.println ("\n *** Warning ***\n");
			rc = true;
			while (warn != null) {
				System.out.println ("SQLState: " +
					warn.getSQLState ());
				System.out.println ("Message:  " +
					warn.getMessage ());
				System.out.println ("Vendor:   " +
					warn.getErrorCode ());
				System.out.println ("");
				warn = warn.getNextWarning ();
			}
		}
		return rc;
	}

	//-------------------------------------------------------------------
	// dispResultSet
	// Displays all columns and rows in the given result set
	//-------------------------------------------------------------------

	private static void dispResultSet (ResultSet rs)
		throws SQLException
	{
		int i;

		// Get the ResultSetMetaData.  This will be used for
		// the column headings

		ResultSetMetaData rsmd = rs.getMetaData ();

		// Get the number of columns in the result set

		int numCols = rsmd.getColumnCount ();

		// Display column headings
		for (i=1; i<=numCols; i++) {
			if (i > 1) System.out.print(",");
			System.out.print(rsmd.getColumnLabel(i));
		}
		System.out.println("");
		
		// Display data, fetching until end of the result set

		boolean more = rs.next ();
		while (more) {

			// Loop through each column, getting the
			// column data and displaying

			for (i=1; i<=numCols; i++) {
				if (i > 1) System.out.print(", ");
//				System.out.print(rs.getString(i));
				System.out.print(rs.getString(rsmd.getColumnName(i)));
			}
			System.out.println("");

			// Fetch the next result set row

			more = rs.next ();
		}
	}
}

